Ruby - Bug #7172

[[Ruby 1.9:]] fix rbconfig for --enable-load-relative (v2)
10/16/2012 10:14 PM - mpapis (Michal Papis)

Status: Closed

Priority: Normal

Assignee: nobu (Nobuyoshi Nakada)

Target version: 2.0.0

ruby -v: 2.0.0dev Backport:
Description

continuation of http://bugs.ruby-lang.org/issues/6903 and http://bugs.ruby-lang.org/issues/7115

Checked with http://bugs.ruby-lang.org/projects/ruby-193/repository/entry/tool/mkconfig.rb and p286,
there is still missing fix for rbconfig, it can be found here:

https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch

it does two things important for movable rubies:

1. https:/github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 27-28 - properly detect libruby
prefix on system with lib64

2. hitps://qithub.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 36 - replace all occurrences of
application prefix with $(prefix) so after moving ruby to other location final system paths are used instead of the build system
paths, this solves number of issues, especially with compilation gem native extensions.

Related issues:
Related to Ruby - Bug #6903: [[Ruby 1.9:]] --enable-load-relative broken on s... Closed 08/22/2012

Associated revisions

Revision ae92565e04071d63867cedd05f48b1{f39664534 - 01/15/2013 07:03 AM - U.Nakamura
merge revision(s) 38776: [Backport #7172]
* tool/mkconfig.rb: use configured libdir value to fix
-—enable-load-relative on systems where libdir is not default value,
overridden in config.site files. [ruby-core:47267] [Bug #6903]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@38828 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision ae92565e - 01/15/2013 07:03 AM - U.Nakamura
merge revision(s) 38776: [Backport #7172]
* tool/mkconfig.rb: use configured libdir value to fix
-—enable-load-relative on systems where libdir is not default value,

overridden in config.site files. [ruby-core:47267] [Bug #6903]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@38828 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/16/2012 10:29 PM - wycats (Yehuda Katz)

Thanks mpapis for moving the ball forward on this. | rely on
--enable-load-relative for Tokaido, and getting/keeping it working reliably
will make me very happy.

Yehuda Katz
(ph) 718.877.1325

On Tue, Oct 16, 2012 at 9:14 AM, mpapis (Michal Papis) mpapis@gmail.comwrote:

Issue #7172 has been reported by mpapis (Michal Papis).

Backport #7172: [[Ruby 1.9:]] fix rbconfig for --enable-load-relative (v2)
https: .ruby-lang.org/i 7172
Author: mpapis (Michal Papis)
Status: Open

Priority: Normal

Assignee:

Category:

Target version:

continuation of http:/bugs.ruby-lang.org/issues/6903 and
http://bugs.ruby-lang.org/issues/7115

Checked with
http://bugs.ruby-lang.org/projects/ruby-193/repository/entry/tool/mkconfig.rband p286,
there is still missing fix for rbconfig, it can be found here:

https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch

it does two things important for movable rubies:

https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 27-28- properly detect libruby prefix on system
with lib64

2.

https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 36- replace all occurrences of application prefix
with $(prefix) so after

moving ruby to other location final system paths are used instead of the

build system paths, this solves number of issues, especially with

compilation gem native extensions.

http://bugs.ruby-lang.org/

#2 - 10/19/2012 01:09 PM - usa (Usaku NAKAMURA)
- Status changed from Open to Closed

Already backport at r37155.
#3 - 10/26/2012 04:02 AM - mpapis (Michal Papis)

@usa (Usaku NAKAMURA) I'm sorry but http://bugs.ruby-lang.org/projects/ruby-193/repository/revisions/37155 does not backport tool/mkconfig.rb
please check again the description.

#4 - 11/08/2012 05:29 PM - usa (Usaku NAKAMURA)
- Status changed from Closed to Open

Oh, sorry, I've mistaken.

#5 - 12/26/2012 10:30 AM - mpapis (Michal Papis)

any chance on getting it merged for 1.9.37? | just found out p362 was released and do not see it included :(

#6 - 12/26/2012 12:29 PM - usa (Usaku NAKAMURA)
- Status changed from Open to Assigned

- Assignee set to usa (Usaku NAKAMURA)

maybe next release.

#7 - 01/11/2013 04:54 PM - usa (Usaku NAKAMURA)

- Tracker changed from Backport to Bug

- Project changed from 13 to Ruby

- Assignee changed from usa (Usaku NAKAMURA) to nobu (Nobuyoshi Nakada)

... This problem is not fixed at trunk (and 2.0.0-rc1), isn't it?

#8 - 01/15/2013 07:25 AM - mpapis (Michal Papis)
partial and a bit improved version is applied here: http://bugs.ruby-lang.org/projects/ruby-trunk/repository/entry/tool/mkconfig.rb - but it is not available
in the 2.0.0-rc1: http:/ftp.ruby-lang.org/pub/ruby/2.0/ruby-2.0.0-rc1.tar.gz

still missing:

e https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L16
e https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 36

this replaces all occurrences of application prefix with $(prefix) so after moving ruby to other location final system paths are used instead of the build
system paths, this solves number of issues, especially with compilation gem native extensions.

#9 - 01/17/2013 04:52 AM - mpapis (Michal Papis)
just took another look on ruby-trunk and there are still two changes missing:

e https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L16
e https://github.com/wayneeseguin/rvm/blob/master/patches/ruby/1.9.3/p286/ruby-multilib.patch#L 36

they are required to allow proper compilation of gems/extensions after ruby is moved to a new location.

would it be possible to get this into 2.0.0-p0 as it was reported already on 1.9.3-p194 (https:/bugs.ruby-lang.org/issues/7115)

#10 - 01/29/2013 04:11 PM - nobu (Nobuyoshi Nakada)
- Category set to build

- Status changed from Assigned to Feedback

- Target version set to 2.0.0

- ruby -v set to 2.0.0dev

How do you run the configure script and which element in RbConfig has prefix expanded?

#11 - 02/01/2013 12:50 AM - mpapis (Michal Papis)

So running:

rvm install ruby-head --debug --movable

Executes:

autoreconf

./configure —--disable-install-doc —--prefix=/home/mpapis/.rvm/rubies/ruby-head —--enable-shared —--enable-load-re
lative —--sysconfdir=/etc --with-opt-dir=/home/mpapis/.rvm/rubies/ruby-head --with-baseruby=/home/mpapis/.rvm/w
rappers/ruby-1.9.3-p374/ruby

make

make install
And this ends up with /home/mpapis/.rvm/rubies/ruby-head/lib64/ruby/2.0.0/x86_64-linux/rbconfig.rb:

CONFIG["configure_args"] = " --disable-install-doc' '--prefix='home/mpapis/.rvm/rubies/ruby-head' '--enable-shared' --enable-load-relative'
"--sysconfdir=/etc' --with-opt-dir='home/mpapis/.rvm/rubies/ruby-head' '--with-baseruby=/home/mpapis/.rvm/wrappers/ruby-1.9.3-p374/ruby’
'CC=ccache gcc™

CONFIG["DLDFLAGS"] = "-L/home/mpapis/.rvm/rubies/ruby-head/lib -WI,-R/home/mpapis/.rvm/rubies/ruby-head/lib "
CONFIG["CPPFLAGS"] = " -I/home/mpapis/.rvm/rubies/ruby-head/include $(DEFS) $(cppflags)"

CONFIG["LDFLAGS"] = "-L. -fstack-protector -rdynamic -WI,-export-dynamic -L/home/mpapis/.rvm/rubies/ruby-head/lib
-WI,-R/home/mpapis/.rvm/rubies/ruby-head/lib "

| understand that is not the usual use case, but any time some libs will be compiled in ruby prefix or using relative path to ruby prefix (assuming lib
was copied along to ruby) - after moving ruby it will not be possible to find those libs.

#12 - 02/19/2013 12:07 AM - mame (Yusuke Endoh)

Sorry but | don't understand both the issue and the status at all.
Any action needed for 2.0.0-p0?

Yusuke Endoh mame@tsg.ne.jp

#13 - 02/19/2013 11:04 AM - nobu (Nobuyoshi Nakada)
- Status changed from Feedback to Closed

Try --with-opt-dir="${prefix}".
r39176 is needed for “make reconfig' to work, though.
